var Avrgirl = require('avrgirl-arduino');

Avrgirl.prototype.sendMessage = function(data, callback) {
  var _this = this;

  // validate board properties first
  _this._validateBoard(function(error) {
    if (error) { return callback(error); }

    // set up serialport connection
    _this.connection._init(function(error) {
      if (error) { return callback(error); }

      console.log(_this.connection);

      _this.connection.serialPort.open(function (error) {
        if ( error ) {
          console.log('failed to open: '+error);
        } else {
          console.log('open');

          _this.connection.serialPort.on('data', function(data) {
            console.log('data received: ' + data);
          });

          // Wait 750ms and then send data, in order to get an echo back
          setTimeout(function() { _this.connection.serialPort.write(data); }, 750);

        }
      });

    });
  });

};