module.exports = {

  "G92": function (model, args) {
    return
  },

  "G91": function(model, args) {
    return
  },

  "G90": function(model, args) {
    return
  },

  "G1": function(model, args) {
    if (args && args.z != undefined) {
      model.currentLayer.z = args.z;
    }

    if (args && args.e !== undefined && args.e > 0 && args.x !== undefined && args.y !== undefined) {
      model.geometryArr.push( [args.x, args.y, model.currentLayer.z, true, model.oldTool] );
    } else if (args && args.e === undefined && args.e > 0 && args.x !== undefined && args.y !== undefined) {
      model.geometryArr.push( [args.x, args.y, model.currentLayer.z, false, model.oldTool] );
    }
  },

  "G0": function(model, args) {
    if (args && args.z != undefined) {
      model.currentLayer.z = args.z;
    }

    if (args && args.x !== undefined && args.y !== undefined) {
      model.geometryArr.push( [args.x, args.y, model.currentLayer.z, false, model.oldTool] );
    }
  },

  "TOOLCHANGE": function(model, args) {
    if (model.firstSwitch == true) {
      model.firstSwitch = false;
      model.oldTool = args.t;
    } else {
      model.oldTool = args.t;
      model.oldDiff = model.Etotal;
    }

    return
  },

  "null": function(model, args) {
    return
  }

}