var THREE = require('three');
var ieee754 = require('ieee754');

module.exports = {
  "G92": function (model, args) {
    return
  },

  "G91": function(model, args) {
    return
  },

  "G90": function(model, args) {
    return
  },

  "G1": function(model, args) {
    if (args && args.z != undefined) {
      model.heightTracking.currentZ = args.z;
    }

    if (model.heightTracking.currentZ != undefined) {
      if (model.layerColourCount[model.heightTracking.currentZ] == undefined) {
        model.layerColourCount[model.heightTracking.currentZ] = [0, 0];
      } else {
        model.layerColourCount[model.heightTracking.currentZ][1] += 1;
      }
    }

    model.lastLayer = args;
    return
  },

  "G0": function(model, args) {
    if (args && args.z != undefined) {
      model.heightTracking.currentZ = args.z;
    }

    if (model.heightTracking.currentZ != undefined) {
      if (model.layerColourCount[model.heightTracking.currentZ] == undefined) {
        model.layerColourCount[model.heightTracking.currentZ] = [0, 0];
      } else {
        model.layerColourCount[model.heightTracking.currentZ][1] += 1;
      }
    }

    return
  },

  "TOOLCHANGE": function(model, args) {
    if (model.heightTracking.currentZ != undefined) {
      if (model.layerColourCount[model.heightTracking.currentZ] == undefined) {
        model.layerColourCount[model.heightTracking.currentZ] = [0, 0];
      };

      //if (model.firstTool == true && model.layerColourCount[model.heightTracking.currentZ][0] == 0 && model.layerColourCount[model.heightTracking.currentZ][1] >= 50) {
      //  model.firstTool = false;
      //};

      if (model.layerColourCount[model.heightTracking.currentZ] != undefined) {
        model.layerColourCount[model.heightTracking.currentZ][0] += 1;
      };

      if (model.layerColourCount[model.heightTracking.currentZ][0] == 1 && model.layerColourCount[model.heightTracking.currentZ][1] == 0) {
        model.layerColourCount[model.heightTracking.currentZ] = [0, 0];
      };

      //console.log(model.heightTracking.currentZ + ' ' + model.layerColourCount[model.heightTracking.currentZ]);
    }

    return
  },

  "null": function(model, args) {
    return
  }
}